-- Horizontal and vertical blinds
module Blinds where

import Pan


vblind :: FloatE -> IntE -> ImageC
vblind f dw = scale (i2f dw,1) $ \ (x,y) -> fadeC f (grey (0.5+x))

-- Notice that we don't use a conditional to cut off grey values outside of
-- [0,1]. The tiling done below cuts out these regions.

hblind :: FloatE -> IntE -> ImageC
hblind f dw = scale (1,i2f dw) $ \ (x,y) -> fadeC f (grey (0.5+y))

vblinds :: FloatE -> IntE -> ImageC
vblinds f dw = tile (i2f dw,10) (vblind f dw)

hblinds :: FloatE -> IntE -> ImageC
hblinds f dw = tile (10,i2f dw) (hblind f dw)

blindUI :: (FloatE -> IntE -> ImageC) -> UI ImageC
blindUI bF = do
  dw <- islider "width" (0,25) 10
  f  <- slider  "opacity" (0,1) 0.6
  return (bF f dw) 

hblindUI :: UI FilterC
hblindUI = do
   im <- blindUI hblinds
   return (over im)

vblindUI :: UI FilterC
vblindUI = do
   im <- blindUI vblinds
   return (over im)

----------------------------------------

makeAll = makeAllFor allBackends

makeAllFor bends = do
  compileFilterFor bends "Horizontal blinds"  hblindUI
  compileFilterFor bends "Vertical blinds"    vblindUI
