// Slider.h: interface for the CSlider class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SLIDER_H__5679AAE8_C80C_4033_928B_03518E5EB848__INCLUDED_)
#define AFX_SLIDER_H__5679AAE8_C80C_4033_928B_03518E5EB848__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Box.h"
#include "EditBox.h"
#include "TrackBar.h"


#define SLIDER_MIN_RANGE 0
#define SLIDER_MAX_RANGE 1000
#define SLIDER_RANGE (SLIDER_MAX_RANGE - SLIDER_MIN_RANGE)

#define ID_EDIT_FIELD 12314
#define ID_TRACKBAR 12315


class CSlider  : public CBox
{
public:
	CSlider();
	virtual ~CSlider();

    HWND Create
		( HWND     hWndParent
		, LPCTSTR  label
		, LPCTSTR  initEditVal
		, int nWidth, int nHeight
		);

    BEGIN_MSG_MAP(CSlider)
        MESSAGE_HANDLER(WM_HSCROLL, OnHScroll)
        MESSAGE_HANDLER(WM_CLOSE, OnClose)
        CHAIN_MSG_MAP(CBox)
    END_MSG_MAP()

    LRESULT OnHScroll(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnClose(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

private:
    CTrackBar* m_tracker;
    CEditBox*  m_edit;
};

#endif // !defined(AFX_SLIDER_H__5679AAE8_C80C_4033_928B_03518E5EB848__INCLUDED_)
